#include "minigui.ch"

FUNCTION main()

DEFINE WINDOW p000win ;
 AT 0,0 ;
 WIDTH 800 ;
 HEIGHT 640 ;
 TITLE 'InputMask Numeric Datatype Test Program' ;
 MAIN ;
 FONT "Arial" ;
 SIZE 12

 DEFINE MAIN MENU
  DEFINE POPUP '&File'
   MENUITEM 'e&Xit' ACTION p000win.Release
  END POPUP
  DEFINE POPUP '&Test'
   MENUITEM '&1 Examples'   ACTION p001_standard()
  END POPUP
 END MENU

END WINDOW
CENTER WINDOW p000win
ACTIVATE WINDOW p000win
RETURN NIL

STATIC FUNCTION p001_standard()
LOCAL cNote := "I think: Input Mask like clipper style."+hb_osnewline()+;
               "dot for decimal separator and comma for thousand separator,"+hb_osnewline()+;
               "but (at this point) I don't understand help document where say:"+hb_osnewline()+;
               "E :   Displays numbers in British format"
LOCAL cMsg1 := "This is standard in USA, GBR, and so on."+hb_osnewline()+;
               "You can see dot as decimal separator and comma like thousand separator."+hb_osnewline()+;
               "You can press dot as first character to enter decimals. Work fine"
LOCAL cMsg2 := "This is standard in ITA, ESP, and so on."+hb_osnewline()+;
               "A) First time you don't see nothing. I think .000"+hb_osnewline()+;
               "B) You can't press comma as first character to enter decimals."+hb_osnewline()+;
               "C) After you have pressed dot (to enter decimals) and leave the field,"+hb_osnewline()+;
               "dot change in comma as decimal separator."+hb_osnewline()+;
               "D) Than, if you come back on this field, comma change in dot."

DEFINE WINDOW p001win ;
 AT 0,0 ;
 WIDTH 800 ;
 HEIGHT 640 ;
 TITLE 'InputMask Numeric Datatype Test Program' ;
 WINDOWTYPE CHILD ;
 FONT "Arial" ;
 SIZE 12

 DEFINE EDITBOX lb_note
  ROW 50
  COL 200
  WIDTH 550
  HEIGHT 90
  VALUE cNote
  VSCROLLBAR .T.
  HSCROLLBAR .T.
  READONLY .T.
  TABSTOP .F.
 END EDITBOX

* gbr, usa, ecc.
 DEFINE TEXTBOX field1
  ROW 200
  COL 20
  HEIGHT 25
  WIDTH 100
  DATATYPE NUMERIC
  INPUTMASK '999,999.999'
  RIGHTALIGN .T.
  ONENTER ValueIs(p001win.field1.Value)
 END TEXTBOX
 DEFINE EDITBOX lb_usa
  ROW 200
  COL 200
  WIDTH 550
  HEIGHT 120
  VALUE cMsg1
  VSCROLLBAR .T.
  HSCROLLBAR .T.
  READONLY .T.
  TABSTOP .F.
 END EDITBOX

* ita, esp, fra, ecc.
 DEFINE TEXTBOX field2
  ROW 400
  COL 20
  HEIGHT 25
  WIDTH 100
  DATATYPE NUMERIC
  INPUTMASK '999,999.999'
  RIGHTALIGN .T.
  ONENTER ValueIs(p001win.field2.Value)
  FORMAT 'E'
 END TEXTBOX
 DEFINE EDITBOX lb_ita
  ROW 400
  COL 200
  WIDTH 550
  HEIGHT 120
  VALUE cMsg2
  VSCROLLBAR .T.
  HSCROLLBAR .T.
  READONLY .T.
  TABSTOP .F.
 END EDITBOX

* wrong
 DEFINE TEXTBOX field3
  ROW 560
  COL 20
  HEIGHT 25
  WIDTH 100
  VALUE 123456.987
  DATATYPE NUMERIC
  INPUTMASK '999.999,999'
*  INPUTMASK '999,999.999' correctly
  RIGHTALIGN .T.
  ONENTER ValueIs(p001win.field1.Value)
  FORMAT 'E'
 END TEXTBOX
 DEFINE LABEL lb_wrong
  ROW 560
  COL 200
  WIDTH 550
  HEIGHT 25
  VALUE "Infact this it's completely wrong syntax: 999.999,999 as InputMask"
 END LABEL

END WINDOW
p001win.field1.Value := 0
p001win.field2.Value := 0

CENTER WINDOW p001win
ACTIVATE WINDOW p001win
RETURN NIL

********************************************
* display value
********************************************
STATIC FUNCTION ValueIs(nValue)
msgStop("VAlue is "+ALLTRIM(STR(nValue)))
RETURN NIL